<?php
	/*	
	*	Goodlayers Framework File
	*	---------------------------------------------------------------------
	*	This file contains the homepage loading button in page option area
	*	---------------------------------------------------------------------
	*/
	
	add_action('add_meta_boxes', 'gdlr_init_demo_page_option');
	if( !function_exists('gdlr_init_demo_page_option') ){
		function gdlr_init_demo_page_option(){
			add_meta_box( 'demo-page-option', 
				__('Load Demo Page', 'gdlr_translate'), 
				'gdlr_create_demo_page_option',
				'page',
				'side',
				'default'
			);
		}
	}
	
	if( !function_exists('gdlr_create_demo_page_option') ){
		function gdlr_create_demo_page_option(){
			global $post;
		
			$buttons = array(
				'homepage' => __('Homepage', 'gdlr_translate'),
				'about' => __('About Us', 'gdlr_translate'),
				'q-a' => __('Q&A', 'gdlr_translate'),
				'careers' => __('Careers', 'gdlr_translate'),
				'honors' => __('Honors & Awards', 'gdlr_translate'),
				'contact-1' => __('Contact 1', 'gdlr_translate'),
				'contact-2' => __('Contact 2', 'gdlr_translate'),
			);
			
			echo '<div id="gdlr-load-demo-wrapper" data-ajax="' . AJAX_URL . '" data-id="' . $post->ID . '" data-action="load_demo_pagebuilder">';
			echo '<em>';
			echo __('*This option allow you to set page item to following pages with one click. Note that to use this option will replace all your current page item setting in this page and <strong>This Can\'t Be Undone</strong>. ( Images are not included. )', 'gdlr_translate');
			echo '</em><div class="clear"></div>';
			foreach( $buttons as $button_slug => $button_title ){
				echo '<input type="button" data-slug="' . $button_slug . '" value="' . $button_title . '" />';
			}
			echo '</div>';

		}
	}
	
	add_action('wp_ajax_load_demo_pagebuilder', 'gdlr_load_demo_pagebuilder');
	if( !function_exists('gdlr_load_demo_pagebuilder') ){
		function gdlr_load_demo_pagebuilder(){
			$default_data = array(
				'homepage' => array(
					'above-sidebar'=>'[]',
					'below-sidebar'=>'[]',
					'content-with-sidebar'=>'[{"item-type":"wrapper","item-builder-title":"Full Size Wrapper","type":"full-size-wrapper","items":[{"item-type":"item","item-builder-title":"Master Slider","type":"master-slider","option":{"page-item-id":"","id":"2","margin-bottom":"0px"}}],"option":{"page-item-id":"","background":"#ffffff","show-section":"gdlr-show-all","border":"none","border-top-color":"#e9e9e9","border-bottom-color":"#e9e9e9","padding-top":"0px","padding-bottom":"0px"}},{"item-type":"wrapper","item-builder-title":"Full Size Wrapper","type":"full-size-wrapper","items":[{"item-type":"item","item-builder-title":"Service Half Background","type":"service-half-background","option":{"page-item-id":"","left-bg-color":"#ec4933","left-icon":"fa-book","left-title":"We are the best full-service firm based in New York","left-content":"Lawyer base has more than 20 years of experiences in this feild and we have solved more than 2000 cases.  Every case is very important to us and we always take care of them seriously. We have 98% of happy clients.","right-bg-image":"4230","right-title":"Something About Us","right-caption":"Pellentesque Adipiscing Purus","margin-bottom":"20px"}}],"option":{"page-item-id":"","background":"#ffffff","show-section":"gdlr-show-all","border":"none","border-top-color":"#e9e9e9","border-bottom-color":"#e9e9e9","padding-top":"0px","padding-bottom":"0px"}},{"item-type":"wrapper","item-builder-title":"Background/Parallax Wrapper","type":"parallax-bg-wrapper","items":[{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-3","items":[{"item-type":"item","item-builder-title":"Image / Frame","type":"image-frame","option":{"page-item-id":"","image-id":"4231","thumbnail-size":"full","link-type":"none","url":"","frame-type":"none","frame-background":"#dddddd","margin-bottom":"0px"}}],"option":{},"size":"1/3"},{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-3","items":[{"item-type":"item","item-builder-title":"Content","type":"content","option":{"page-item-id":"","title-type":"none","title":"","caption":"","right-text":"Read All News","right-text-link":"","content":"","margin-bottom":"50px"}},{"item-type":"item","item-builder-title":"Column Service","type":"column-service","option":{"page-item-id":"","icon":"fa-car","title":"Ultricies Ipsum","style":"type-1","content":"<p>Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum nibh, ut fermentum massa justo sit amet risus. Sed posuere consec.</p>","margin-bottom":"27px"}},{"item-type":"item","item-builder-title":"Column Service","type":"column-service","option":{"page-item-id":"","icon":"fa-users","title":"Vehicula Malesuada Nullam","style":"type-1","content":"<p>Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum nibh, ut fermentum massa justo sit amet risus. Sed posuere consec.</p>","margin-bottom":"27px"}},{"item-type":"item","item-builder-title":"Column Service","type":"column-service","option":{"page-item-id":"","icon":"fa-bank","title":"Venenatis Consectetur","style":"type-1","content":"<p>Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum nibh, ut fermentum massa justo sit amet risus. Sed posuere consec.</p>","margin-bottom":"20px"}}],"option":{},"size":"1/3"},{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-3","items":[{"item-type":"item","item-builder-title":"Content","type":"content","option":{"page-item-id":"","title-type":"none","title":"","caption":"","right-text":"Read All News","right-text-link":"","content":"","margin-bottom":"50px"}},{"item-type":"item","item-builder-title":"Column Service","type":"column-service","option":{"page-item-id":"","icon":"fa-support","title":"Tristique Purus Ridiculus","style":"type-1","content":"<p>Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum nibh, ut fermentum massa justo sit amet risus. Sed posuere consec.</p>","margin-bottom":"27px"}},{"item-type":"item","item-builder-title":"Column Service","type":"column-service","option":{"page-item-id":"","icon":"fa-ambulance","title":"Sollicitudin Magna","style":"type-1","content":"<p>Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum nibh, ut fermentum massa justo sit amet risus. Sed posuere consec.</p>","margin-bottom":"27px"}},{"item-type":"item","item-builder-title":"Column Service","type":"column-service","option":{"page-item-id":"","icon":"fa-home","title":"Tortor Lorem Ultricies","style":"type-1","content":"<p>Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum nibh, ut fermentum massa justo sit amet risus. Sed posuere consec.</p>","margin-bottom":"20px"}}],"option":{},"size":"1/3"}],"option":{"page-item-id":"","type":"image","background":"4233","background-mobile":"","background-speed":"0.1","pattern":"1","video":"","video-overlay":"0.5","video-player":"enable","skin":"gdlr-skin-dark-skin","show-section":"gdlr-show-all","border":"none","border-top-color":"#e9e9e9","border-bottom-color":"#e9e9e9","padding-top":"60px","padding-bottom":"0px"}},{"item-type":"item","item-builder-title":"Stunning Text","type":"stunning-text","option":{"page-item-id":"","title":"Are you having any problems but can\'t consult to anyone?","caption":"Talk to us! We promise we can help you! <strong>Call Now! (1)223-3344-334</strong>","stunning-text-icon":"fa-phone","margin-bottom":"67px"}},{"item-type":"item","item-builder-title":"Practice","type":"practice","option":{"page-item-id":"","title-type":"center","title":"Legal Practice Areas","caption":"","right-text":"View All Practices","right-text-link":"http://themes.goodlayers2.com/lawyerbase/practice-areas-modern-3-columns/","category":"","practice-style":"modern-style","practice-size":"1/4","num-fetch":"8","num-excerpt":"20","practice-layout":"fitRows","practice-filter":"disable","thumbnail-size":"small-grid-size","orderby":"date","order":"desc","pagination":"disable","margin-bottom":"40px"}},{"item-type":"wrapper","item-builder-title":"Color Wrapper","type":"color-wrapper","items":[{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-2","items":[{"item-type":"item","item-builder-title":"Testimonial","type":"testimonial","option":{"page-item-id":"","testimonial":"[{|gq2|gdl-tab-author-image-url|gq2|:|gq2|http://themes.goodlayers2.com/lawyerbase/wp-content/uploads/2015/04/testi-hp-3.jpg|gq2|,|gq2|gdl-tab-author-image|gq2|:|gq2|4247|gq2|,|gq2|gdl-tab-title|gq2|:|gq2|Oliver Shansder|gq2|,|gq2|gdl-tab-position|gq2|:|gq2|Father of two sons|gq2|,|gq2|gdl-tab-content|gq2|:|gq2|<span style=|gq6|font-size: 17px; color: #333; font-weight: 600; margin-bottom: 12px; display: inline-block;|gq6|>Lawyer Base just saved my life!</span>|g2n|Aenean lacinia bibendum nulla sed cons ectetur. Morbi leo risus, porta ac conse ctet ur ac, vesti bulum at eros. Etiam porta sem mal esuada magna mollis euismod. Etiam porta sem malesuada magna mo llis eu. Donec ullamcorper nulla non metus auctor.|gq2|},{|gq2|gdl-tab-author-image-url|gq2|:|gq2|http://themes.goodlayers2.com/lawyerbase/wp-content/uploads/2015/04/testi-hp-2.jpg|gq2|,|gq2|gdl-tab-author-image|gq2|:|gq2|4246|gq2|,|gq2|gdl-tab-title|gq2|:|gq2|Santana White|gq2|,|gq2|gdl-tab-position|gq2|:|gq2|Car Accident|gq2|,|gq2|gdl-tab-content|gq2|:|gq2|<span style=|gq6|font-size: 17px; color: #333; font-weight: 600; margin-bottom: 12px; display: inline-block;|gq6|>I got my money back!</span>|g2n|Aenean lacinia bibendum nulla sed cons ectetur. Morbi leo risus, porta ac conse ctet ur ac, vesti bulum at eros. Etiam porta sem mal esuada magna mollis euismod. Etiam porta sem malesuada magna mo llis eu. Donec ullamcorper nulla non metus auctor.|gq2|},{|gq2|gdl-tab-author-image-url|gq2|:|gq2|http://themes.goodlayers2.com/lawyerbase/wp-content/uploads/2015/04/testi-hp-1.jpg|gq2|,|gq2|gdl-tab-author-image|gq2|:|gq2|4245|gq2|,|gq2|gdl-tab-title|gq2|:|gq2|James Bond|gq2|,|gq2|gdl-tab-position|gq2|:|gq2|Financial Issue|gq2|,|gq2|gdl-tab-content|gq2|:|gq2|<span style=|gq6|font-size: 17px; color: #333; font-weight: 600; margin-bottom: 12px; display: inline-block;|gq6|>Now I can get my business running!</span>|g2n|Aenean lacinia bibendum nulla sed cons ectetur. Morbi leo risus, porta ac conse ctet ur ac, vesti bulum at eros. Etiam porta sem mal esuada magna mollis euismod. Etiam porta sem malesuada magna mo llis eu. Donec ullamcorper nulla non metus auctor.|gq2|}]","title-type":"left-divider","title":"Testimonial","caption":"","testimonial-columns":"1","testimonial-type":"carousel","testimonial-style":"modern-style","margin-bottom":"20px"}}],"option":{},"size":"1/2"},{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-2","items":[{"item-type":"item","item-builder-title":"Blog","type":"blog","option":{"page-item-id":"","title-type":"left-divider","title":"Recent News","caption":"","right-text":"Read All News","right-text-link":"http://themes.goodlayers2.com/lawyerbase/blog-full-with-right-sidebar/","category":"","tag":"","num-excerpt":"9","num-fetch":"3","blog-style":"blog-widget","blog-layout":"fitRows","thumbnail-size":"thumbnail","orderby":"date","order":"desc","offset":"","pagination":"disable","enable-sticky":"disable","margin-bottom":"0px"}}],"option":{},"size":"1/2"}],"option":{"page-item-id":"","background-type":"color","background":"#f5f5f5","skin":"gdlr-skin-light-grey","show-section":"gdlr-show-all","border":"none","border-top-color":"#e9e9e9","border-bottom-color":"#e9e9e9","padding-top":"65px","padding-bottom":"40px"}},{"item-type":"wrapper","item-builder-title":"Color Wrapper","type":"color-wrapper","items":[{"item-type":"item","item-builder-title":"Attorney","type":"attorney","option":{"page-item-id":"","title-type":"center-divider","title":"Meet Our Attorneys","caption":"","right-text":"Read All News","right-text-link":"","category":"","attorney-size":"1/4","num-fetch":"7","num-excerpt":"18","attorney-layout":"carousel","thumbnail-size":"small-grid-size","orderby":"date","order":"desc","pagination":"disable","margin-bottom":"0px"}}],"option":{"page-item-id":"","background-type":"color","background":"#ffffff","skin":"no-skin","show-section":"gdlr-show-all","border":"none","border-top-color":"#e9e9e9","border-bottom-color":"#e9e9e9","padding-top":"70px","padding-bottom":"0px"}},{"item-type":"wrapper","item-builder-title":"Background/Parallax Wrapper","type":"parallax-bg-wrapper","items":[{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-2","items":[{"item-type":"item","item-builder-title":"Title","type":"title","option":{"page-item-id":"","title-type":"center","title":"Don\'t hesitate to ask","caption":"Law is complicate matter. It can cause you a big problem <br/>if you ignore it. Let us help you!","right-text":"Read All News","right-text-link":"","margin-bottom":"45px"}},{"item-type":"item","item-builder-title":"Content","type":"content","option":{"page-item-id":"","title-type":"none","title":"","caption":"","right-text":"Read All News","right-text-link":"","content":"<p>[contact-form-7 id=|gq2|4260|gq2| title=|gq2|Contact Homepage|gq2|]</p>","margin-bottom":"20px"}}],"option":{},"size":"1/2"},{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-2","items":[{"item-type":"item","item-builder-title":"Image / Frame","type":"image-frame","option":{"page-item-id":"","image-id":"4259","thumbnail-size":"full","link-type":"none","url":"","frame-type":"none","frame-background":"#dddddd","margin-bottom":"0px"}}],"option":{},"size":"1/2"}],"option":{"page-item-id":"","type":"image","background":"4258","background-mobile":"","background-speed":"0","pattern":"1","video":"","video-overlay":"0.5","video-player":"enable","skin":"gdlr-skin-dark-skin","show-section":"gdlr-show-all","border":"none","border-top-color":"#e9e9e9","border-bottom-color":"#e9e9e9","padding-top":"70px","padding-bottom":"0px"}},{"item-type":"wrapper","item-builder-title":"Color Wrapper","type":"color-wrapper","items":[{"item-type":"item","item-builder-title":"Banner","type":"banner","option":{"page-item-id":"","slider":"[[4265,4267,4268,4269,4270,4271],{|gq2|4263|gq2|:{|gq2|title|gq2|:|gq2||gq2|,|gq2|caption|gq2|:|gq2||gq2|,|gq2|caption-position|gq2|:|gq2||gq2|,|gq2|slide-link|gq2|:|gq2||gq2|,|gq2|url|gq2|:|gq2||gq2|,|gq2|new-tab|gq2|:|gq2|enable|gq2|,|gq2|thumbnail|gq2|:|gq2|http://themes.goodlayers2.com/lawyerbase/wp-content/uploads/2015/04/banner-1-150x117.jpg|gq2|,|gq2|width|gq2|:150,|gq2|height|gq2|:117},|gq2|4265|gq2|:{|gq2|title|gq2|:|gq2||gq2|,|gq2|caption|gq2|:|gq2||gq2|,|gq2|caption-position|gq2|:|gq2||gq2|,|gq2|slide-link|gq2|:|gq2|none|gq2|,|gq2|url|gq2|:|gq2||gq2|,|gq2|new-tab|gq2|:|gq2|enable|gq2|,|gq2|thumbnail|gq2|:|gq2|http://themes.goodlayers2.com/lawyerbase/wp-content/uploads/2015/04/banner-1-150x117.jpg|gq2|,|gq2|width|gq2|:150,|gq2|height|gq2|:117},|gq2|4267|gq2|:{|gq2|title|gq2|:|gq2||gq2|,|gq2|caption|gq2|:|gq2||gq2|,|gq2|caption-position|gq2|:|gq2||gq2|,|gq2|slide-link|gq2|:|gq2||gq2|,|gq2|url|gq2|:|gq2||gq2|,|gq2|new-tab|gq2|:|gq2|enable|gq2|,|gq2|thumbnail|gq2|:|gq2|http://themes.goodlayers2.com/lawyerbase/wp-content/uploads/2015/04/banner-2-150x117.jpg|gq2|,|gq2|width|gq2|:150,|gq2|height|gq2|:117},|gq2|4268|gq2|:{|gq2|title|gq2|:|gq2||gq2|,|gq2|caption|gq2|:|gq2||gq2|,|gq2|caption-position|gq2|:|gq2||gq2|,|gq2|slide-link|gq2|:|gq2||gq2|,|gq2|url|gq2|:|gq2||gq2|,|gq2|new-tab|gq2|:|gq2|enable|gq2|,|gq2|thumbnail|gq2|:|gq2|http://themes.goodlayers2.com/lawyerbase/wp-content/uploads/2015/04/banner-3-150x117.jpg|gq2|,|gq2|width|gq2|:150,|gq2|height|gq2|:117},|gq2|4269|gq2|:{|gq2|title|gq2|:|gq2||gq2|,|gq2|caption|gq2|:|gq2||gq2|,|gq2|caption-position|gq2|:|gq2||gq2|,|gq2|slide-link|gq2|:|gq2||gq2|,|gq2|url|gq2|:|gq2||gq2|,|gq2|new-tab|gq2|:|gq2|enable|gq2|,|gq2|thumbnail|gq2|:|gq2|http://themes.goodlayers2.com/lawyerbase/wp-content/uploads/2015/04/banner-4-150x117.jpg|gq2|,|gq2|width|gq2|:150,|gq2|height|gq2|:117},|gq2|4270|gq2|:{|gq2|title|gq2|:|gq2||gq2|,|gq2|caption|gq2|:|gq2||gq2|,|gq2|caption-position|gq2|:|gq2||gq2|,|gq2|slide-link|gq2|:|gq2||gq2|,|gq2|url|gq2|:|gq2||gq2|,|gq2|new-tab|gq2|:|gq2|enable|gq2|,|gq2|thumbnail|gq2|:|gq2|http://themes.goodlayers2.com/lawyerbase/wp-content/uploads/2015/04/banner-5-150x117.jpg|gq2|,|gq2|width|gq2|:150,|gq2|height|gq2|:117},|gq2|4271|gq2|:{|gq2|title|gq2|:|gq2||gq2|,|gq2|caption|gq2|:|gq2||gq2|,|gq2|caption-position|gq2|:|gq2||gq2|,|gq2|slide-link|gq2|:|gq2||gq2|,|gq2|url|gq2|:|gq2||gq2|,|gq2|new-tab|gq2|:|gq2|enable|gq2|,|gq2|thumbnail|gq2|:|gq2|http://themes.goodlayers2.com/lawyerbase/wp-content/uploads/2015/04/banner-6-150x117.jpg|gq2|,|gq2|width|gq2|:150,|gq2|height|gq2|:117}}]","title-type":"center-divider","title":"Some Of Our Clients","caption":"","thumbnail-size":"full","banner-columns":"5","margin-bottom":"20px"}}],"option":{"page-item-id":"","background-type":"color","background":"#ffffff","skin":"no-skin","show-section":"gdlr-show-all","border":"none","border-top-color":"#e9e9e9","border-bottom-color":"#e9e9e9","padding-top":"70px","padding-bottom":"45px"}}]', 
					'post-option'=>'{"sidebar":"no-sidebar","left-sidebar":"Footer 1","right-sidebar":"Footer 1","page-style":"normal","show-title":"disable","page-caption":"","show-content":"enable","header-background":""}'
				),
				'about' => array(
					'above-sidebar'=>'[]',
					'below-sidebar'=>'[]',
					'content-with-sidebar'=>'[{"item-type":"wrapper","item-builder-title":"Color Wrapper","type":"color-wrapper","items":[{"item-type":"wrapper","item-builder-title":"Column Item","type":"column2-5","items":[{"item-type":"item","item-builder-title":"Content","type":"content","option":{"page-item-id":"","title-type":"none","title":"","caption":"","right-text":"Read All News","right-text-link":"","content":"","margin-bottom":"0px"}},{"item-type":"item","item-builder-title":"Image / Frame","type":"image-frame","option":{"page-item-id":"","image-id":"4017","thumbnail-size":"full","link-type":"none","url":"","frame-type":"none","frame-background":"#dddddd","margin-bottom":"20px"}}],"option":{},"size":"2/5"},{"item-type":"wrapper","item-builder-title":"Column Item","type":"column2-5","items":[{"item-type":"item","item-builder-title":"List With Icon","type":"icon-with-list","option":{"page-item-id":"","icon-with-list":"[{|gq2|gdl-tab-icon|gq2|:|gq2|fa-rotate-right|gq2|,|gq2|gdl-tab-title|gq2|:|gq2|Condimentum Porta Aenean|gq2|,|gq2|gdl-tab-content|gq2|:|gq2|Cras justo odio, dapibus ac facilisis in, egestas eget quam. Integer posuere erat a ante venenatis dapibus posuere velit aliquet. Praesent commodo cursus magna, vel scelerisque nisl consectetur et. Cum sociis natoque penatibus et magnis dis parturient montes.|gq2|},{|gq2|gdl-tab-icon|gq2|:|gq2|fa-circle-o-notch|gq2|,|gq2|gdl-tab-title|gq2|:|gq2|Etiam Justo Ullamcorper|gq2|,|gq2|gdl-tab-content|gq2|:|gq2|Cras justo odio, dapibus ac facilisis in, egestas eget quam. Integer posuere erat a ante venenatis dapibus posuere velit aliquet. Praesent commodo cursus magna, vel scelerisque nisl consectetur et. Cum sociis natoque penatibus et magnis dis parturient montes.|gq2|},{|gq2|gdl-tab-icon|gq2|:|gq2|fa-heart-o|gq2|,|gq2|gdl-tab-title|gq2|:|gq2|Inceptos Vulputate Fusce|gq2|,|gq2|gdl-tab-content|gq2|:|gq2|Cras justo odio, dapibus ac facilisis in, egestas eget quam. Integer posuere erat a ante venenatis dapibus posuere velit aliquet. Praesent commodo cursus magna, vel scelerisque nisl consectetur et. Cum sociis natoque penatibus et magnis dis parturient montes.|gq2|},{|gq2|gdl-tab-icon|gq2|:|gq2|fa-star-o|gq2|,|gq2|gdl-tab-title|gq2|:|gq2|Dapibus Mattis Parturient|gq2|,|gq2|gdl-tab-content|gq2|:|gq2|Cras justo odio, dapibus ac facilisis in, egestas eget quam. Integer posuere erat a ante venenatis dapibus posuere velit aliquet. Praesent commodo cursus magna, vel scelerisque nisl consectetur et. Cum sociis natoque penatibus et magnis dis parturient montes.|gq2|}]","title-type":"none","title":"","caption":"","align":"left","margin-bottom":"20px"}}],"option":{},"size":"3/5"}],"option":{"page-item-id":"","background-type":"color","background":"#f4f4f4","skin":"no-skin","show-section":"gdlr-show-all","border":"none","border-top-color":"#e9e9e9","border-bottom-color":"#e9e9e9","padding-top":"100px","padding-bottom":"60px"}},{"item-type":"wrapper","item-builder-title":"Color Wrapper","type":"color-wrapper","items":[{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-2","items":[{"item-type":"item","item-builder-title":"Column Service","type":"column-service","option":{"page-item-id":"","icon":"fa-book","title":"Tortor Tellus Cras","style":"type-2","content":"<p>Aenean lacinia bibendum nulla sed consectetur. Fusce dapibus, tellus ac cursus commodo, tortor mauris condi mentum nibh. Porta Aenean Adipiscing.</p>","margin-bottom":"20px"}}],"option":{},"size":"1/3"},{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-4","items":[{"item-type":"item","item-builder-title":"Column Service","type":"column-service","option":{"page-item-id":"","icon":"fa-bank","title":"Dolor Fusce Ligula","style":"type-2","content":"<p>Aenean lacinia bibendum nulla sed consectetur. Fusce dapibus, tellus ac cursus commodo, tortor mauris condi mentum nibh. Porta Aenean Adipiscing.</p>","margin-bottom":"20px"}}],"option":{},"size":"1/3"},{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-4","items":[{"item-type":"item","item-builder-title":"Column Service","type":"column-service","option":{"page-item-id":"","icon":"fa-automobile","title":"Inceptos Dolor Mollis","style":"type-2","content":"<p>Aenean lacinia bibendum nulla sed consectetur. Fusce dapibus, tellus ac cursus commodo, tortor mauris condi mentum nibh. Porta Aenean Adipiscing.</p>","margin-bottom":"20px"}}],"option":{},"size":"1/3"}],"option":{"page-item-id":"","background-type":"color","background":"#ffffff","skin":"no-skin","show-section":"gdlr-show-all","border":"none","border-top-color":"#e9e9e9","border-bottom-color":"#e9e9e9","padding-top":"60px","padding-bottom":"30px"}},{"item-type":"wrapper","item-builder-title":"Background/Parallax Wrapper","type":"parallax-bg-wrapper","items":[{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-2","items":[{"item-type":"item","item-builder-title":"Feature Media","type":"feature-media","option":{"page-item-id":"","type":"image","video-url":"","image":"","thumbnail-size":"thumbnail","title-type":"left","title":"Story About US","caption":"","align":"left","content":"<p>Cras mattis consectetur purus sit amet fermentum. Etiam porta sem malesuada magna mollis euismod. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Maecenas sed diam eget risus varius blandit sit amet non magna. Cras justo odio, dapibus ac facilisis in. Vivamus sagittis lacus vel augue laoreet rutrum faucibus dolor auctor.Nullam quis risus eget urna mollis ornare vel eu leo. Maecenas sed diam eget risus varius blandit sit amet non magna.</p><p>[gdlr_space height=|gq2|30px|gq2|]</p><p>[gdlr_button href=|gq2|#|gq2| target=|gq2|_self|gq2| size=|gq2|medium|gq2| background=|gq2|#ec4933|gq2| color=|gq2|#ffffff|gq2|]Learn More[/gdlr_button]</p>","button-text":"Learn More","button-link":"","margin-bottom":"20px"}}],"option":{},"size":"1/2"},{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-2","items":[{"item-type":"item","item-builder-title":"Skill Bar","type":"skill-bar","option":{"page-item-id":"","content":"Banking & Financial","percent":"100","size":"small","icon":"icon-picture","text-color":"#ffffff","background-color":"#e9e9e9","progress-color":"#ec4933","margin-bottom":"40px"}},{"item-type":"item","item-builder-title":"Skill Bar","type":"skill-bar","option":{"page-item-id":"","content":"Corporate Issue","percent":"80","size":"small","icon":"icon-code","text-color":"#ffffff","background-color":"#e9e9e9","progress-color":"#ec4933","margin-bottom":"40px"}},{"item-type":"item","item-builder-title":"Skill Bar","type":"skill-bar","option":{"page-item-id":"","content":"Family Law","percent":"85","size":"small","icon":"","text-color":"#ffffff","background-color":"#e9e9e9","progress-color":"#ec4933","margin-bottom":"40px"}},{"item-type":"item","item-builder-title":"Skill Bar","type":"skill-bar","option":{"page-item-id":"","content":"Real Estate","percent":"70","size":"small","icon":"","text-color":"#ffffff","background-color":"#e9e9e9","progress-color":"#ec4933","margin-bottom":"20px"}}],"option":{},"size":"1/2"}],"option":{"page-item-id":"","type":"image","background":"4012","background-mobile":"","background-speed":"0.2","pattern":"1","video":"","video-overlay":"0.5","video-player":"enable","skin":"gdlr-skin-dark-skin","show-section":"gdlr-show-all","border":"none","border-top-color":"#e9e9e9","border-bottom-color":"#e9e9e9","padding-top":"90px","padding-bottom":"50px"}},{"item-type":"wrapper","item-builder-title":"Color Wrapper","type":"color-wrapper","items":[{"item-type":"item","item-builder-title":"Stunning Text","type":"stunning-text","option":{"page-item-id":"","title":"Commodo Tellus Sit Sem","caption":"Nullam id dolor id nibh ultricies vehicula ut id elit. Aenean lacinia bibendum nulla sed consectetur. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Donec sed odio dui. Donec sed odio dui. Morbi leo risus, porta ac consectetur ac, vestibulum at eros. Curabitur blandit tempus porttitor. Vestibulum id ligula porta felis euismod semper. ","stunning-text-icon":"fa-phone","margin-bottom":"20px"}}],"option":{"page-item-id":"","background-type":"color","background":"#ec4933","skin":"gdlr-skin-dark-service","show-section":"gdlr-show-all","border":"none","border-top-color":"#e9e9e9","border-bottom-color":"#e9e9e9","padding-top":"90px","padding-bottom":"60px"}}]', 
					'post-option'=>'{"sidebar":"no-sidebar","left-sidebar":"blog","right-sidebar":"blog","page-style":"normal","show-title":"enable","page-caption":"Example Of About Us Page","show-content":"enable","header-background":""}'
				),
				'q-a' => array(
					'above-sidebar'=>'[]',
					'below-sidebar'=>'[{"item-type":"wrapper","item-builder-title":"Background/Parallax Wrapper","type":"parallax-bg-wrapper","items":[{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-5","items":[],"option":{},"size":"1/5"},{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-5","items":[{"item-type":"item","item-builder-title":"Content","type":"content","option":{"page-item-id":"","title-type":"center-divider","title":"Can\'t find answer? Ask Us.","caption":"","right-text":"Read All News","right-text-link":"","content":"<p>[contact-form-7 id=|gq2|4260|gq2| title=|gq2|Contact Homepage|gq2|]</p>","margin-bottom":"20px"}}],"option":{},"size":"3/5"},{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-5","items":[],"option":{},"size":"1/5"}],"option":{"page-item-id":"","type":"image","background":"4258","background-mobile":"","background-speed":"0","pattern":"1","video":"","video-overlay":"0.5","video-player":"enable","skin":"gdlr-skin-dark-service","show-section":"gdlr-show-all","border":"none","border-top-color":"#e9e9e9","border-bottom-color":"#e9e9e9","padding-top":"80px","padding-bottom":"15px"}}]',
					'content-with-sidebar'=>'[{"item-type":"item","item-builder-title":"Accordion","type":"accordion","option":{"page-item-id":"","accordion":"[{|gq2|gdl-tab-title|gq2|:|gq2|Bibendum Porta Fermentum?|gq2|,|gq2|gdl-tab-content|gq2|:|gq2|Donec sed odio dui. Maecenas sed diam eget risus varius blandit sit amet non magna. Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum nibh, ut fermentum massa justo sit amet risus. Donec id elit non mi porta gravida at eget metus. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum.|g2n||g2n|<ul>|g2n|<li>Cras justo odio, dapibus ac facilisis in, egestas eget quam.</li>|g2n|<li>Etiam porta sem malesuada magna mollis euismod.</li>|g2n|<li>Aenean lacinia bibendum nulla sed consectetur.</li>|g2n|<li>Cras justo odio, dapibus ac facilisis in, egestas eget quam.</li>|g2n|</ul>|g2n||g2n|Etiam porta sem malesuada magna mollis euismod. Cras mattis consectetur purus sit amet fermentum. Donec sed odio dui. Curabitur blandit tempus porttitor. Nullam quis risus eget urna mollis ornare vel eu leo.|g2n||g2n|Nullam quis risus eget urna mollis ornare vel eu leo. Nulla vitae elit libero, a pharetra augue. Sed posuere consectetur est at lobortis. Curabitur blandit tempus porttitor. Maecenas sed diam eget risus varius blandit sit amet non magna. Nullam quis risus eget urna mollis ornare vel eu leo.|g2n||g2n|[gdlr_button href=|gq6|http://themeforest.net/user/GoodLayers|gq6| target=|gq6|_self|gq6| size=|gq6|small|gq6| background=|gq6|#ec4933|gq6| color=|gq6|#ffffff|gq6|]Learn More[/gdlr_button]|gq2|},{|gq2|gdl-tab-title|gq2|:|gq2|Quam Elit Malesuada Magna?|gq2|,|gq2|gdl-tab-content|gq2|:|gq2|Donec sed odio dui. Maecenas sed diam eget risus varius blandit sit amet non magna. Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum nibh, ut fermentum massa justo sit amet risus. Donec id elit non mi porta gravida at eget metus. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum.|g2n||g2n|<ul>|g2n|<li>Cras justo odio, dapibus ac facilisis in, egestas eget quam.</li>|g2n|<li>Etiam porta sem malesuada magna mollis euismod.</li>|g2n|<li>Aenean lacinia bibendum nulla sed consectetur.</li>|g2n|<li>Cras justo odio, dapibus ac facilisis in, egestas eget quam.</li>|g2n|</ul>|g2n||g2n|Etiam porta sem malesuada magna mollis euismod. Cras mattis consectetur purus sit amet fermentum. Donec sed odio dui. Curabitur blandit tempus porttitor. Nullam quis risus eget urna mollis ornare vel eu leo.|g2n||g2n|Nullam quis risus eget urna mollis ornare vel eu leo. Nulla vitae elit libero, a pharetra augue. Sed posuere consectetur est at lobortis. Curabitur blandit tempus porttitor. Maecenas sed diam eget risus varius blandit sit amet non magna. Nullam quis risus eget urna mollis ornare vel eu leo.|g2n||g2n|[gdlr_button href=|gq6|http://themeforest.net/user/GoodLayers|gq6| target=|gq6|_self|gq6| size=|gq6|small|gq6| background=|gq6|#ec4933|gq6| color=|gq6|#ffffff|gq6|]Learn More[/gdlr_button]|gq2|},{|gq2|gdl-tab-title|gq2|:|gq2|Praesent commodo cursus magna, vel scelerisque nisl consectetur et?|gq2|,|gq2|gdl-tab-content|gq2|:|gq2|Donec sed odio dui. Maecenas sed diam eget risus varius blandit sit amet non magna. Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum nibh, ut fermentum massa justo sit amet risus. Donec id elit non mi porta gravida at eget metus. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum.|g2n||g2n|<ul>|g2n|<li>Cras justo odio, dapibus ac facilisis in, egestas eget quam.</li>|g2n|<li>Etiam porta sem malesuada magna mollis euismod.</li>|g2n|<li>Aenean lacinia bibendum nulla sed consectetur.</li>|g2n|<li>Cras justo odio, dapibus ac facilisis in, egestas eget quam.</li>|g2n|</ul>|g2n||g2n|Etiam porta sem malesuada magna mollis euismod. Cras mattis consectetur purus sit amet fermentum. Donec sed odio dui. Curabitur blandit tempus porttitor. Nullam quis risus eget urna mollis ornare vel eu leo.|g2n||g2n|Nullam quis risus eget urna mollis ornare vel eu leo. Nulla vitae elit libero, a pharetra augue. Sed posuere consectetur est at lobortis. Curabitur blandit tempus porttitor. Maecenas sed diam eget risus varius blandit sit amet non magna. Nullam quis risus eget urna mollis ornare vel eu leo.|g2n||g2n|[gdlr_button href=|gq6|http://themeforest.net/user/GoodLayers|gq6| target=|gq6|_self|gq6| size=|gq6|small|gq6| background=|gq6|#ec4933|gq6| color=|gq6|#ffffff|gq6|]Learn More[/gdlr_button]|gq2|},{|gq2|gdl-tab-title|gq2|:|gq2|Sem Purus Bibendum Pharetra?|gq2|,|gq2|gdl-tab-content|gq2|:|gq2|Donec sed odio dui. Maecenas sed diam eget risus varius blandit sit amet non magna. Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum nibh, ut fermentum massa justo sit amet risus. Donec id elit non mi porta gravida at eget metus. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum.|g2n||g2n|<ul>|g2n|<li>Cras justo odio, dapibus ac facilisis in, egestas eget quam.</li>|g2n|<li>Etiam porta sem malesuada magna mollis euismod.</li>|g2n|<li>Aenean lacinia bibendum nulla sed consectetur.</li>|g2n|<li>Cras justo odio, dapibus ac facilisis in, egestas eget quam.</li>|g2n|</ul>|g2n||g2n|Etiam porta sem malesuada magna mollis euismod. Cras mattis consectetur purus sit amet fermentum. Donec sed odio dui. Curabitur blandit tempus porttitor. Nullam quis risus eget urna mollis ornare vel eu leo.|g2n||g2n|Nullam quis risus eget urna mollis ornare vel eu leo. Nulla vitae elit libero, a pharetra augue. Sed posuere consectetur est at lobortis. Curabitur blandit tempus porttitor. Maecenas sed diam eget risus varius blandit sit amet non magna. Nullam quis risus eget urna mollis ornare vel eu leo.|g2n||g2n|[gdlr_button href=|gq6|http://themeforest.net/user/GoodLayers|gq6| target=|gq6|_self|gq6| size=|gq6|small|gq6| background=|gq6|#ec4933|gq6| color=|gq6|#ffffff|gq6|]Learn More[/gdlr_button]|gq2|},{|gq2|gdl-tab-title|gq2|:|gq2|Praesent commodo cursus magna, vel scelerisque nisl consectetur et?|gq2|,|gq2|gdl-tab-content|gq2|:|gq2|Donec sed odio dui. Maecenas sed diam eget risus varius blandit sit amet non magna. Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum nibh, ut fermentum massa justo sit amet risus. Donec id elit non mi porta gravida at eget metus. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum.|g2n||g2n|<ul>|g2n|<li>Cras justo odio, dapibus ac facilisis in, egestas eget quam.</li>|g2n|<li>Etiam porta sem malesuada magna mollis euismod.</li>|g2n|<li>Aenean lacinia bibendum nulla sed consectetur.</li>|g2n|<li>Cras justo odio, dapibus ac facilisis in, egestas eget quam.</li>|g2n|</ul>|g2n||g2n|Etiam porta sem malesuada magna mollis euismod. Cras mattis consectetur purus sit amet fermentum. Donec sed odio dui. Curabitur blandit tempus porttitor. Nullam quis risus eget urna mollis ornare vel eu leo.|g2n||g2n|Nullam quis risus eget urna mollis ornare vel eu leo. Nulla vitae elit libero, a pharetra augue. Sed posuere consectetur est at lobortis. Curabitur blandit tempus porttitor. Maecenas sed diam eget risus varius blandit sit amet non magna. Nullam quis risus eget urna mollis ornare vel eu leo.|g2n||g2n|[gdlr_button href=|gq6|http://themeforest.net/user/GoodLayers|gq6| target=|gq6|_self|gq6| size=|gq6|small|gq6| background=|gq6|#ec4933|gq6| color=|gq6|#ffffff|gq6|]Learn More[/gdlr_button]|gq2|},{|gq2|gdl-tab-title|gq2|:|gq2|Sollicitudin Fermentum Risus Commodo Nibh?|gq2|,|gq2|gdl-tab-content|gq2|:|gq2|Donec sed odio dui. Maecenas sed diam eget risus varius blandit sit amet non magna. Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum nibh, ut fermentum massa justo sit amet risus. Donec id elit non mi porta gravida at eget metus. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum.|g2n||g2n|<ul>|g2n|<li>Cras justo odio, dapibus ac facilisis in, egestas eget quam.</li>|g2n|<li>Etiam porta sem malesuada magna mollis euismod.</li>|g2n|<li>Aenean lacinia bibendum nulla sed consectetur.</li>|g2n|<li>Cras justo odio, dapibus ac facilisis in, egestas eget quam.</li>|g2n|</ul>|g2n||g2n|Etiam porta sem malesuada magna mollis euismod. Cras mattis consectetur purus sit amet fermentum. Donec sed odio dui. Curabitur blandit tempus porttitor. Nullam quis risus eget urna mollis ornare vel eu leo.|g2n||g2n|Nullam quis risus eget urna mollis ornare vel eu leo. Nulla vitae elit libero, a pharetra augue. Sed posuere consectetur est at lobortis. Curabitur blandit tempus porttitor. Maecenas sed diam eget risus varius blandit sit amet non magna. Nullam quis risus eget urna mollis ornare vel eu leo.|g2n||g2n|[gdlr_button href=|gq6|http://themeforest.net/user/GoodLayers|gq6| target=|gq6|_self|gq6| size=|gq6|small|gq6| background=|gq6|#ec4933|gq6| color=|gq6|#ffffff|gq6|]Learn More[/gdlr_button]|gq2|}]","title-type":"none","title":"","caption":"","initial-state":"1","style":"style-1","margin-bottom":"60px"}}]', 
					'post-option'=>'{"sidebar":"left-sidebar","left-sidebar":"Q&A","right-sidebar":"Footer 1","page-style":"normal","show-title":"enable","page-caption":"Aenean Cras Tortor","show-content":"enable","header-background":""}'
				),
				'careers' => array(
					'above-sidebar'=>'[]',
					'below-sidebar'=>'[]',
					'content-with-sidebar'=>'[{"item-type":"wrapper","item-builder-title":"Background/Parallax Wrapper","type":"parallax-bg-wrapper","items":[{"item-type":"item","item-builder-title":"Title","type":"title","option":{"page-item-id":"","title-type":"center-divider","title":"Positions Available","caption":"Come and join our family","right-text":"Read All News","right-text-link":"","margin-bottom":"20px"}}],"option":{"page-item-id":"","type":"image","background":"4332","background-mobile":"","background-speed":"0.2","pattern":"1","video":"","video-overlay":"0.5","video-player":"enable","skin":"gdlr-skin-dark-service","show-section":"gdlr-show-all","border":"none","border-top-color":"#e9e9e9","border-bottom-color":"#e9e9e9","padding-top":"160px","padding-bottom":"100px"}},{"item-type":"wrapper","item-builder-title":"Color Wrapper","type":"color-wrapper","items":[{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-3","items":[{"item-type":"item","item-builder-title":"Column Service","type":"column-service","option":{"page-item-id":"","icon":"fa-dot-circle-o","title":"Individual Employment Negotiation and Litigation","style":"type-1","content":"<p>New York, NY</p>","margin-bottom":"20px"}}],"option":{},"size":"1/3"},{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-3","items":[{"item-type":"item","item-builder-title":"Column Service","type":"column-service","option":{"page-item-id":"","icon":"fa-dot-circle-o","title":"Class Action Practice Group","style":"type-1","content":"<p>New York, NY</p>","margin-bottom":"20px"}}],"option":{},"size":"1/3"},{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-3","items":[{"item-type":"item","item-builder-title":"Column Service","type":"column-service","option":{"page-item-id":"","icon":"fa-dot-circle-o","title":"Executives & Professionals Practice Group","style":"type-1","content":"<p>San Diego, CA</p>","margin-bottom":"20px"}}],"option":{},"size":"1/3"},{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-3","items":[{"item-type":"item","item-builder-title":"Column Service","type":"column-service","option":{"page-item-id":"","icon":"fa-dot-circle-o","title":"Associate Class Action Practice Group","style":"type-1","content":"<p>Washington, D.C.</p>","margin-bottom":"20px"}}],"option":{},"size":"1/3"},{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-3","items":[{"item-type":"item","item-builder-title":"Column Service","type":"column-service","option":{"page-item-id":"","icon":"fa-dot-circle-o","title":"Individual Employment Negotiation and Litigation","style":"type-1","content":"<p>San Diego, CA</p>","margin-bottom":"20px"}}],"option":{},"size":"1/3"},{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-3","items":[{"item-type":"item","item-builder-title":"Column Service","type":"column-service","option":{"page-item-id":"","icon":"fa-dot-circle-o","title":"Regulatory Compliance Associate Attorney","style":"type-1","content":"<p>San Diego, CA</p>","margin-bottom":"20px"}}],"option":{},"size":"1/3"},{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-3","items":[{"item-type":"item","item-builder-title":"Column Service","type":"column-service","option":{"page-item-id":"","icon":"fa-dot-circle-o","title":"Corporate Litigation Associate","style":"type-1","content":"<p>Washington, D.C.</p>","margin-bottom":"20px"}}],"option":{},"size":"1/3"},{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-3","items":[{"item-type":"item","item-builder-title":"Column Service","type":"column-service","option":{"page-item-id":"","icon":"fa-dot-circle-o","title":"Associate Attorney - Computer Engineering","style":"type-1","content":"<p>Phoenix, AZ</p>","margin-bottom":"20px"}}],"option":{},"size":"1/3"},{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-3","items":[{"item-type":"item","item-builder-title":"Column Service","type":"column-service","option":{"page-item-id":"","icon":"fa-dot-circle-o","title":"Structured Finance Associate","style":"type-1","content":"<p>Phoenix, AZ</p>","margin-bottom":"20px"}}],"option":{},"size":"1/3"}],"option":{"page-item-id":"","background-type":"color","background":"#f5f5f5","skin":"no-skin","show-section":"gdlr-show-all","border":"none","border-top-color":"#e9e9e9","border-bottom-color":"#e9e9e9","padding-top":"65px","padding-bottom":"15px"}},{"item-type":"wrapper","item-builder-title":"Color Wrapper","type":"color-wrapper","items":[{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-2","items":[{"item-type":"item","item-builder-title":"Content","type":"content","option":{"page-item-id":"","title-type":"left","title":"Application Process","caption":"","right-text":"Read All News","right-text-link":"","content":"<p>[gdlr_heading tag=|gq2|span|gq2| size=|gq2|16px|gq2| color=|gq2|#333333|gq2| font_weight=|gq2|bold|gq2|]1. Download Application[/gdlr_heading]<br /> Aenean lacinia bibendum nulla sed consectetur.<br /> <a href=|gq2|#|gq2|>Download</a></p><p>[gdlr_space height=|gq2|20px|gq2|]<br /> [gdlr_heading tag=|gq2|span|gq2| size=|gq2|16px|gq2| color=|gq2|#333333|gq2| font_weight=|gq2|bold|gq2|]2. Fill Informations[/gdlr_heading]<br /> Sed posuere consectetur est at lobortis.</p><p>[gdlr_space height=|gq2|20px|gq2|]<br /> [gdlr_heading tag=|gq2|span|gq2| size=|gq2|16px|gq2| color=|gq2|#333333|gq2| font_weight=|gq2|bold|gq2|]3. Send Back To Us[/gdlr_heading]<br /> Cras mattis consectetur purus sit amet fermentum.</p><p>[gdlr_space height=|gq2|30px|gq2|]</p><p>[gdlr_button href=|gq2|http://themes.goodlayers2.com/lawyerbase/contact-page/|gq2| target=|gq2|_self|gq2| size=|gq2|medium|gq2| background=|gq2|#111|gq2| color=|gq2|#ffffff|gq2|]Contact US[/gdlr_button]</p>","margin-bottom":"20px"}}],"option":{},"size":"1/3"},{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-2","items":[{"item-type":"item","item-builder-title":"Content","type":"content","option":{"page-item-id":"","title-type":"left","title":"Job Requirements","caption":"","right-text":"Read All News","right-text-link":"","content":"<p><strong>Maecenas faucibus mollis interdum.</strong> Maecenas faucibus mollis interdum. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nullam quis risus eget urna mollis ornare vel eu leo. Nullam id dolor id nibh ultricies vehicula ut id elit. Etiam porta sem malesuada magna mollis euismod. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum.</p><ul><li>Cras justo odio, dapibus ac facilisis in, egestas eget quam.</li><li>Fringilla Sem Sollicitudin Porta</li><li>Donec ullamcorper nulla non metus auctor fringilla.</li><li>Curabitur blandit tempus porttitor.</li></ul><p>Curabitur blandit tempus porttitor. Integer posuere erat a ante venenatis dapibus posuere velit aliquet. Curabitur blandit tempus porttitor. Donec id elit non mi porta gravida at eget metus. Vestibulum id ligula porta felis euismod semper. Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum nibh, ut fermentum massa justo sit amet risus. Duis mollis, est non commodo luctus, nisi erat porttitor ligula, eget lacinia odio sem nec elit. Morbi leo risus, porta ac consectetur ac, vestibulum at eros.</p>","margin-bottom":"20px"}}],"option":{},"size":"2/3"}],"option":{"page-item-id":"","background-type":"color","background":"#ffffff","skin":"no-skin","show-section":"gdlr-show-all","border":"none","border-top-color":"#e9e9e9","border-bottom-color":"#e9e9e9","padding-top":"70px","padding-bottom":"45px"}},{"item-type":"wrapper","item-builder-title":"Color Wrapper","type":"color-wrapper","items":[{"item-type":"item","item-builder-title":"Video","type":"video","option":{"page-item-id":"","url":"https://www.youtube.com/watch?v=p8AB1BjvzDw","margin-bottom":"20px"}}],"option":{"page-item-id":"","background-type":"color","background":"#f5f5f5","skin":"no-skin","show-section":"gdlr-show-all","border":"none","border-top-color":"#e9e9e9","border-bottom-color":"#e9e9e9","padding-top":"60px","padding-bottom":"40px"}},{"item-type":"wrapper","item-builder-title":"Full Size Wrapper","type":"full-size-wrapper","items":[{"item-type":"item","item-builder-title":"Service Half Background","type":"service-half-background","option":{"page-item-id":"","left-bg-color":"#1d1d1d","left-icon":"fa-bullhorn","left-title":"We are the best full-service firm based in New York","left-content":"Lawyer base has more than 20 years of experiences in this feild and we have solved more than 2000 cases.  Every case is very important to us and we always take care of them seriously. We have 98% of happy clients.","right-bg-image":"4230","right-title":"Something About Us","right-caption":"Pellentesque Adipiscing Purus","margin-bottom":"20px"}}],"option":{"page-item-id":"","background":"#ffffff","show-section":"gdlr-show-all","border":"none","border-top-color":"#e9e9e9","border-bottom-color":"#e9e9e9","padding-top":"0px","padding-bottom":"0px"}}]', 
					'post-option'=>'{"sidebar":"no-sidebar","left-sidebar":"Footer 1","right-sidebar":"Footer 1","page-style":"normal","show-title":"disable","page-caption":"","show-content":"enable","header-background":""}'
				),
				'honors' => array(
					'above-sidebar'=>'[]',
					'below-sidebar'=>'[]',
					'content-with-sidebar'=>'[{"item-type":"item","item-builder-title":"Content","type":"content","option":{"page-item-id":"","title-type":"none","title":"","caption":"","right-text":"Read All News","right-text-link":"","content":"<p>[gdlr_process min_height=|gq2|280px|gq2| type=|gq2|vertical|gq2| ]</p><p>[gdlr_tab icon=|gq2|fa-trophy|gq2| title=|gq2|2011 LCFM Law Awards|gq2| ]</p><p>Qui ipsorum lingua Celtae, nostra Galli appellantur. Paullum deliquit, ponderibus modulisque suis ratio utitur. Me non paenitet nullum festiviorem excogitasse ad hoc. Curabitur est gravida et libero vitae dictum.</p><p><img class=|gq2| wp-image-4392  aligncenter|gq2| style=|gq2|width: 234px;|gq2| src=|gq2|http://themes.goodlayers2.com/lawyerbase/wp-content/uploads/2015/04/award-4.jpg|gq2| alt=|gq2|award-4|gq2| width=|gq2|234|gq2| height=|gq2|142|gq2| /></p><p>[/gdlr_tab]</p><p>[gdlr_tab icon=|gq2|fa-trophy|gq2| title=|gq2|2013 IFLP Asia Award|gq2| ]</p><p>Qui ipsorum lingua Celtae, nostra Galli appellantur. Paullum deliquit, ponderibus modulisque suis ratio utitur. Me non paenitet nullum festiviorem excogitasse ad hoc. Curabitur est gravida et libero vitae dictum.</p><p><img class=|gq2| wp-image-4391  aligncenter|gq2| style=|gq2|width: 222px;|gq2| src=|gq2|http://themes.goodlayers2.com/lawyerbase/wp-content/uploads/2015/04/award-3.jpg|gq2| alt=|gq2|award-3|gq2| width=|gq2|222|gq2| height=|gq2|260|gq2| /></p><p>[/gdlr_tab]</p><p>[gdlr_tab icon=|gq2|fa-trophy|gq2| title=|gq2|2014 Family Law Awards|gq2| ]</p><p>Qui ipsorum lingua Celtae, nostra Galli appellantur. Paullum deliquit, ponderibus modulisque suis ratio utitur. Me non paenitet nullum festiviorem excogitasse ad hoc. Curabitur est gravida et libero vitae dictum.</p><p><img class=|gq2| wp-image-4390  aligncenter|gq2| style=|gq2|width: 253px;|gq2| src=|gq2|http://themes.goodlayers2.com/lawyerbase/wp-content/uploads/2015/04/award-2.jpg|gq2| alt=|gq2|award-2|gq2| width=|gq2|253|gq2| height=|gq2|237|gq2| /></p><p>[/gdlr_tab]</p><p>[gdlr_tab icon=|gq2|fa-trophy|gq2| title=|gq2|2014 CLaw Award|gq2| ]</p><p>Qui ipsorum lingua Celtae, nostra Galli appellantur. Paullum deliquit, ponderibus modulisque suis ratio utitur. Me non paenitet nullum festiviorem excogitasse ad hoc. Curabitur est gravida et libero vitae dictum.</p><p><img class=|gq2|  wp-image-4385 aligncenter|gq2| style=|gq2|width: 275px;|gq2| src=|gq2|http://themes.goodlayers2.com/lawyerbase/wp-content/uploads/2015/04/award-1.jpg|gq2| alt=|gq2|award-1|gq2| width=|gq2|275|gq2| height=|gq2|107|gq2| /></p><p>[/gdlr_tab]</p><p>[/gdlr_process]</p>","margin-bottom":"20px"}}]',
					'post-option'=>'{"sidebar":"right-sidebar","left-sidebar":"Footer 1","right-sidebar":"Q&A","page-style":"normal","show-title":"enable","page-caption":"Aenean Cras Tortor","show-content":"enable","header-background":""}'
				),
				'contact-1' => array(
					'above-sidebar'=>'[{"item-type":"wrapper","item-builder-title":"Full Size Wrapper","type":"full-size-wrapper","items":[{"item-type":"item","item-builder-title":"Content","type":"content","option":{"page-item-id":"","title-type":"none","title":"","caption":"","right-text":"Read All News","right-text-link":"","content":"<p>[put_wpgm id=1]</p>","margin-bottom":"0px"}}],"option":{"page-item-id":"","background":"#ffffff","show-section":"gdlr-show-all","border":"none","border-top-color":"#dddddd","border-bottom-color":"#dddddd","padding-top":"0px","padding-bottom":"0px"}}]',
					'below-sidebar'=>'[{"item-type":"wrapper","item-builder-title":"Background/Parallax Wrapper","type":"parallax-bg-wrapper","items":[{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-2","items":[{"item-type":"item","item-builder-title":"Box Icon","type":"box-icon-item","option":{"page-item-id":"","icon":"fa-envelope","icon-position":"top","icon-type":"circle","icon-color":"#ffffff","icon-background":"#ec4933","title":"Contact By Email","content":"<p>Lorem ipsum dolor sit amet, consectetur adipisici elit, sed eiusmod tempor incidunt ut labore et dolore magna aliqua.</p>","margin-bottom":"20px"}}],"option":{},"size":"1/3"},{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-2","items":[{"item-type":"item","item-builder-title":"Box Icon","type":"box-icon-item","option":{"page-item-id":"","icon":"fa-phone","icon-position":"top","icon-type":"circle","icon-color":"#ffffff","icon-background":"#ec4933","title":"Contact By Phone","content":"<p>Lorem ipsum dolor sit amet, consectetur adipisici elit, sed eiusmod tempor incidunt ut labore et dolore magna aliqua.</p>","margin-bottom":"20px"}}],"option":{},"size":"1/3"},{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-3","items":[{"item-type":"item","item-builder-title":"Box Icon","type":"box-icon-item","option":{"page-item-id":"","icon":"fa-home","icon-position":"top","icon-type":"circle","icon-color":"#ffffff","icon-background":"#ec4933","title":"Come To See Us","content":"<p>Lorem ipsum dolor sit amet, consectetur adipisici elit, sed eiusmod tempor incidunt ut labore et dolore magna aliqua.</p>","margin-bottom":"20px"}}],"option":{},"size":"1/3"}],"option":{"page-item-id":"","type":"image","background":"4012","background-mobile":"","background-speed":"0.2","pattern":"1","video":"","video-overlay":"0.5","video-player":"enable","skin":"no-skin","show-section":"gdlr-show-all","border":"none","border-top-color":"#dddddd","border-bottom-color":"#dddddd","padding-top":"100px","padding-bottom":"50px"}}]',
					'content-with-sidebar'=>'[{"item-type":"item","item-builder-title":"Content","type":"content","option":{"page-item-id":"","title-type":"none","title":"","caption":"","right-text":"Read All News","right-text-link":"","content":"<p>[gdlr_space height=|gq2|-22px|gq2|] [gdlr_heading tag=|gq2|h5|gq2| font_weight=|gq2|bold|gq2| ]Please fulfil the form below. [/gdlr_heading] [gdlr_space height=|gq2|25px|gq2|] [contact-form-7 id=|gq2|4|gq2| title=|gq2|Contact form 1|gq2|]</p>","margin-bottom":"60px"}}]', 
					'post-option'=>'{"sidebar":"right-sidebar","left-sidebar":"Footer 1","right-sidebar":"contact","page-style":"normal","show-title":"disable","page-caption":"","show-content":"enable","header-background":""}'
				),
				'contact-2' => array(
					'above-sidebar'=>'[]',
					'below-sidebar'=>'[{"item-type":"wrapper","item-builder-title":"Full Size Wrapper","type":"full-size-wrapper","items":[{"item-type":"item","item-builder-title":"Content","type":"content","option":{"page-item-id":"","title-type":"none","title":"","caption":"","right-text":"Read All News","right-text-link":"","content":"<p>[put_wpgm id=1]</p>","margin-bottom":"0px"}}],"option":{"page-item-id":"","background":"#ffffff","show-section":"gdlr-show-all","border":"none","border-top-color":"#d8d8d8","border-bottom-color":"#dddddd","padding-top":"0px","padding-bottom":"0px"}}]',
					'content-with-sidebar'=>'[{"item-type":"item","item-builder-title":"Content","type":"content","option":{"page-item-id":"","title-type":"none","title":"","caption":"","right-text":"Read All News","right-text-link":"","content":"<p>[gdlr_space height=|gq2|-22px|gq2|] [gdlr_heading tag=|gq2|h5|gq2| font_weight=|gq2|bold|gq2| ]Please fulfil the form below.[/gdlr_heading] [gdlr_space height=|gq2|25px|gq2|] [contact-form-7 id=|gq2|4|gq2| title=|gq2|Contact form 1|gq2|]</p>","margin-bottom":"60px"}}]', 
					'post-option'=>'{"sidebar":"left-sidebar","left-sidebar":"contact","right-sidebar":"contact","page-style":"normal","show-title":"enable","page-caption":"Aenean eu leo quam. Pellentesque ornare sem.","show-content":"enable","header-background":""}'
				),			
			);

			$loaded_data = $default_data[$_POST['slug']];
			foreach( $loaded_data as $meta_key => $meta_value ){
				update_post_meta($_POST['post_id'], $meta_key, $meta_value);
			}
		}
	}
?>